<databaseChangeLog xmlns="http://www.liquibase.org/xml/ns/dbchangelog" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://www.liquibase.org/xml/ns/dbchangelog http://www.liquibase.org/xml/ns/dbchangelog/dbchangelog-3.2.xsd">
    <changeSet  author="SYSTEM" id="DUKH-15-transaction-summary-report.xml" runOnChange="true" runInTransaction="true">
        <createProcedure dbms="h2,!oracle, postgresql" encoding="UTF-8" >
            <![CDATA[CREATE OR REPLACE FUNCTION transaction_summary_report(sessid character varying, OUT c_dbtransaction refcursor)
            RETURNS refcursor
            LANGUAGE plpgsql
            AS $$
            BEGIN
            OPEN C_DBTRANSACTION for
            SELECT DISTINCT(SELECT LOCALTIMESTAMP) AS CREATIONDATE  ,SESSIONID,SUM(TOTALAMOUNT) AS TOTALAMOUNT ,SUM(totalcharge) AS TOTALCHARGE,
            (select txdirection.id from MPAY_TRANSACTIONDIRECTIONS txDirection where txDirection.id = transaction.DIRECTIONID) AS DIRECTION,
            (select id from MPAY_MESSAGETYPES where id =(select messagetypeid from MPAY_ENDPOINTOPERATIONS where id = transaction.refoperationid)) AS MESSAGETYPE
            FROM
            MPAY_TRANSACTIONS transaction
            WHERE
            PROCESSINGSTATUSID = 1 AND SESSIONID = SESSID
            GROUP BY REFOPERATIONID,DIRECTIONID,SESSIONID;
            RETURN;
            END; $$
            ;]]>
        </createProcedure>
    </changeSet>
</databaseChangeLog>
